import java.util.*;

public class Arraz {

    public static int sumValuesOfArray(int[] input) {

        int sum = 0;

        for(int i : input) {
            sum += i;
        }
        return sum;
    }

    public static double sumDoublesOfArray(double[] input) {

        double sum = 0;

        for(double d : input) {
            sum += d;
        }
        return sum;
    }

    public static int averageOfArray(int[] input) {
        return sumValuesOfArray(input) / input.length;
    }

    public static double doubleAverageOfArray(double[] input) {
        return sumDoublesOfArray(input) / input.length;
    }

    public static boolean containsValue(int[] input, int numb) {

        for(int i: input) {
            if(i == numb)
            return true;
        }
        return false;
    }

    public static int[] reverseArray(int[] input) {

        int highEnd = input.length - 1;
        int lowEnd = 0;

        while(highEnd > lowEnd) {
            int temp = input[lowEnd];
            input[lowEnd] = input[highEnd];
            input[highEnd] = temp;
            highEnd--;
            lowEnd++;
        }

        return input;
    }


    public static OddEven getOddEvensOfArray(int[] input) {
        int odds = 0;
        int evens = 0;

        for(int i: input) {
            if(i % 2 == 0) {
                evens++;
            } else {
                odds++;
            }
        }
        return new OddEven(odds, evens);
    }

    public static int findIndexOf(int[] input, int numb) {

        for (int i = 0; i < input.length; i++) {
            if(input[i] == numb)
                return i;
        }
        return -1;
    }

    public static Integer[] copyArrayByIterator(Integer[] input) {

        Iterator<Integer> it = Arrays.asList(input).iterator();
        Integer[] output = new Integer[input.length];
        int index = 0;

        while(it.hasNext()) {
            output[index] = it.next();
            index++;
        }
        return output;
    }

    public static int[] copyArrayByLoop(int[] input) {

        int[] output = new int[input.length];

        for (int i = 0; i < input.length; i++) {
            output[i] = input[i];
        }

        return output;
    }

    public static int[] copyArraySetLength(int[] input, int length) {

        int[] output = new int[length];

        for (int i = 0; i < length; i++) {
            output[i] = input[i];
        }

        return output;
    }

    public static int[] removeElementFromArray(int[] input, int numb) {

        int[] output = new int[input.length - 1];
        int index = 0;
        for(int i: input) {
            if(i != numb) {
                output[index] = i;
                index++;
            }
        }
        return output;
    }

    public static int[] insertIntoArrayAt(int[] input, int numb, int index) {

        if(index > input.length) {
            throw new IndexOutOfBoundsException();
        }

        int[] output = new int[input.length + 1];

        for (int i = 0; i < output.length; i++) {
            if(i < index) {
                output[i] = input[i];
            } else if(i == index) {
                output[i] = numb;
            } else {
                output[i] = input[i - 1];
            }
        }
        return output;
    }

    public static MaxMin findMaxMinOfArray(int[] input) {
        int max = input[0];
        int min = input[0];

        for(int i: input) {
            if(i > max)
                max = i;
            if(i < min)
                min = i;
        }
        return new MaxMin(max, min);
    }

    public static int[] removeDupesFromArray(int[] input) {
        int[] output = new int[input.length];
        int index = 0;
        for(int i: input) {
            if(!containsValue(output, i)) {
                output[index] = i;
                index++;
            }
        }
        return copyArraySetLength(output, index);
    }

    public static int find2ndLargestValueFromArray(int[] input) {
        int max = findMaxMinOfArray(input).getMax();
        int[] newArr = removeElementFromArray(input, max);
        return findMaxMinOfArray(newArr).getMax();
    }


    public static ArrayList<Integer> makeMeAnArrayListFromArray(int[] input) {

        ArrayList<Integer> list = new ArrayList<Integer>();

        for(int i: input){
            list.add(i);
        }
        return list;

    }

    public static int[] makeMeAnArrayFromArrayList(ArrayList<Integer> input) {

        int[] array = new int[input.size()];
        int index = 0;

        for(Integer i: input) {
            array[index] = i;
            index++;
        }
        return array;
    }


    public static boolean check2ArraysForEqual(int[] input1, int[] input2) {

        for (int i = 0; i < input1.length; i++) {
            if(input1[i] != input2[i]) {
                return false;
            }
        }
        return true;
    }

    public static int averageArrayWithoutMaxMin(int[] input) {
        int max = findMaxMinOfArray(input).getMax();
        int[] noMax = removeElementFromArray(input, max);
        int min = findMaxMinOfArray(noMax).getMin();
        int[] noMaxMin = removeElementFromArray(noMax, min);
        return averageOfArray(noMaxMin);
    }

    public static boolean arrayHas65and77(int[] input) {

        return (containsValue(input, 65) && containsValue(input,77));
    }

    public static boolean totalOfTensIs30(int[] input) {

        int count = 0;

        for(int i: input) {
            if(i == 10)
            count++;
        }
        if(count == 3)
            return true;

        return false;
    }

    public static int find2ndSmallestValueFromArray(int[] input) {

        int min = findMaxMinOfArray(input).getMin();
        int[] noMin = removeElementFromArray(input, min);
        return findMaxMinOfArray(noMin).getMin();
    }

    public static int[] reverseCopyOfArray(int[] input) {
        return reverseArray(input);
    }

    public static int[] removeLastItem(int[] input) {
        return removeElementFromArray(input, input[input.length - 1]);
    }

    public static int[] removeFirstItem(int[] input) {
        return removeElementFromArray(input, input[0]);
    }

    public static int[] insertAtStart(int[] input, int numb) {
        return insertIntoArrayAt(input, numb, 0);
    }

    public static int[] insertAtEnd(int[] input, int numb) {
        return insertIntoArrayAt(input, numb, input.length);
    }

    public static int[] sortArrayIntoEvensThenOdds(int[] input) {
        int[] output = new int[input.length];
        int frontIndex = 0;
        int backIndex = input.length - 1;
        for (int i : input) {
            if(i % 2 == 0) {
                output[frontIndex] = i;
                frontIndex++;
            } else {
                output[backIndex] = i;
                backIndex--;
            }
        }
        return output;
    }
}
