import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;
import java.util.Arrays;

import static org.junit.Assert.*;

public class ArrazTest {

    @Test
    public void test1SumValuesOfArray() {
        int[] input = {3, 4, 9, 2, 1};
        int expected = 19;
        int actual = Arraz.sumValuesOfArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test2SumValuesOfArray() {
        int[] input = {8};
        int expected = 8;
        int actual = Arraz.sumValuesOfArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test3SumValuesOfArray() {
        int[] input = {6, 5, -3, -2, -6};
        int expected = 0;
        int actual = Arraz.sumValuesOfArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test1SumDoublesOfArray() {
        double[] input = {3.2, 4.55, 9.0, 2.34, 1.7};
        double expected = 20.79;
        double actual = Arraz.sumDoublesOfArray(input);

        Assert.assertEquals(expected, actual, 0.01);
    }

    @Test
    public void test2SumDoublesOfArray() {
        double[] input = {5.24789};
        double expected = 5.24789;
        double actual = Arraz.sumDoublesOfArray(input);

        Assert.assertEquals(expected, actual, 0.01);
    }

    @Test
    public void test1AverageOfArray() {
        int[] input = {3, 4, 9, 3, 1};
        int expected = 4;
        int actual = Arraz.averageOfArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test2AverageOfArray() {
        int[] input = {8};
        int expected = 8;
        int actual = Arraz.averageOfArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test3AverageOfArray() {
        int[] input = {6, 5, -3, -2, -6};
        int expected = 0;
        int actual = Arraz.averageOfArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test4AverageOfArray() {
        int[] input = {3, 4, 9, 3, 1, 8};
        int expected = 4;
        int actual = Arraz.averageOfArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test1AverageDoublesOfArray() {
        double[] input = {3.2, 4.55, 9.0, 2.34, 1.7};
        double expected = 4.158;
        double actual = Arraz.doubleAverageOfArray(input);

        Assert.assertEquals(expected, actual, 0.01);
    }

    @Test
    public void test2AverageDoublesOfArray() {
        double[] input = {5.24789};
        double expected = 5.24789;
        double actual = Arraz.sumDoublesOfArray(input);

        Assert.assertEquals(expected, actual, 0.01);
    }

    @Test
    public void test3AverageDoublesOfArray() {
        double[] input = {3.2, 4.55, 9.0, 2.34, 1.7, 3.3};
        double expected = 4.015;
        double actual = Arraz.doubleAverageOfArray(input);

        Assert.assertEquals(expected, actual, 0.01);
    }

    @Test
    public void test1ContainsValue() {
        int[] input = {3, 4, 9, 2, 1};
        int numb = 9;

        assertTrue(Arraz.containsValue(input, numb));
    }

    @Test
    public void test2ContainsValue() {
        int[] input = {3, 4, 9, 2, 1};
        int numb = 11;

        assertFalse(Arraz.containsValue(input, numb));
    }

    @Test
    public void test1ReverseArray() {
        int[] input = {3, 4, 9, 2, 1};
        int[] expected = {1, 2, 9, 4, 3};
        int[] actual = Arraz.reverseArray(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test2ReverseArray() {
        int[] input = {8, 2};
        int[] expected = {2, 8};
        int[] actual = Arraz.reverseArray(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test1getOddEvens() {
        int[] input = {3, 4, 9, 2, 1};
        OddEven expected = new OddEven(3, 2);
        OddEven actual = Arraz.getOddEvensOfArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test2getOddEvens() {
        int[] input = {8, 2};
        OddEven expected = new OddEven(0, 2);
        OddEven actual = Arraz.getOddEvensOfArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test1findIndexOf() {
        int[] input = {3, 4, 9, 2, 1};
        int numb = 2;
        int expected = 3;
        int actual = Arraz.findIndexOf(input, numb);

        assertEquals(expected, actual);
    }

    @Test
    public void test2findIndexOf() {
        int[] input = {8, 2};
        int numb = 5;
        int expected = -1;
        int actual = Arraz.findIndexOf(input, numb);

        assertEquals(expected, actual);
    }

    @Test
    public void test1copyArrayIterator() {
        Integer[] input = {3, 4, 9, 2, 1};
        Integer[] actual = Arraz.copyArrayByIterator(input);

        assertTrue(Arrays.equals(input, actual));
    }

    @Test
    public void test2copyArrayIterator() {
        Integer[] input = {8, 2};
        Integer[] actual = Arraz.copyArrayByIterator(input);

        assertTrue(Arrays.equals(input, actual));
    }

    @Test
    public void test1copyArrayLoop() {
        int[] input = {3, 4, 9, 2, 1};
        int[] actual = Arraz.copyArrayByLoop(input);

        assertTrue(Arrays.equals(input, actual));
    }

    @Test
    public void test2copyArrayLoop() {
        int[] input = {8, 2};
        int[] actual = Arraz.copyArrayByLoop(input);

        assertTrue(Arrays.equals(input, actual));
    }

    @Test
    public void test1removeElement() {
        int[] input = {3, 4, 9, 2, 1};
        int numb = 2;
        int[] output = Arraz.removeElementFromArray(input, numb);

        assertFalse(Arraz.containsValue(output, numb));
    }

    @Test
    public void test2removeElement() {
        int[] input = {8, 2};
        int numb = 2;
        int[] output = Arraz.removeElementFromArray(input, numb);

        assertFalse(Arraz.containsValue(output, numb));
    }

    @Test
    public void test1insertIntoArrayAt() {
        int[] input = {3, 4, 9, 2, 1};
        int numb = 7;
        int index = 4;
        int[] output = Arraz.insertIntoArrayAt(input, numb, index);
        int actual = Arraz.findIndexOf(output, numb);

        assertEquals(index, actual);
    }

    @Test
    public void test2insertIntoArrayAt() {
        int[] input = {8, 2};
        int numb = 7;
        int index = 0;
        int[] output = Arraz.insertIntoArrayAt(input, numb, index);
        int actual = Arraz.findIndexOf(output, numb);

        assertEquals(index, actual);
    }

    @Test
    public void test3insertIntoArrayAt() {
        int[] input = {8, 2};
        int numb = 7;
        int index = 2;
        int[] output = Arraz.insertIntoArrayAt(input, numb, index);
        int actual = Arraz.findIndexOf(output, numb);

        assertEquals(index, actual);
    }

    @Test(expected = IndexOutOfBoundsException.class)
    public void test4insertIntoArrayAt() {
        int[] input = {8, 2};
        int numb = 7;
        int index = 10;
        int[] output = Arraz.insertIntoArrayAt(input, numb, index);
    }

    @Test
    public void test1findMaxMin() {
        int[] input = {3, 4, 9, 2, 1};
        MaxMin expected = new MaxMin(9, 1);
        MaxMin actual = Arraz.findMaxMinOfArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test2findMaxMin() {
        int[] input = {8, 2};
        MaxMin expected = new MaxMin(8, 2);
        MaxMin actual = Arraz.findMaxMinOfArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test1removeDups() {
        int[] input = {3, 4, 9, 2, 1, 3, 9, 3};
        int[] expected = {3, 4, 9, 2, 1};
        int[] actual = Arraz.removeDupesFromArray(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test2removeDups() {
        int[] input = {8, 2, 8, 8, 8, 8, 8, 8, 1};
        int[] expected = {8, 2, 1};
        int[] actual = Arraz.removeDupesFromArray(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test1find2ndLargest() {
        int[] input = {3, 4, 9, 2, 1};
        int expected = 4;
        int actual = Arraz.find2ndLargestValueFromArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test2find2ndLargest() {
        int[] input = {8, 2, 3, 5, 7, 1, 9};
        int expected = 8;
        int actual = Arraz.find2ndLargestValueFromArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test1listFromArray() {
        int[] input = {3, 4, 9, 2, 1};
        ArrayList<Integer> expected = new ArrayList<Integer>();
        expected.add(3);
        expected.add(4);
        expected.add(9);
        expected.add(2);
        expected.add(1);
        ArrayList<Integer> actual = Arraz.makeMeAnArrayListFromArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test2ListFromArray() {
        int[] input = {8, 2};
        ArrayList<Integer> expected = new ArrayList<Integer>();
        expected.add(8);
        expected.add(2);
        ArrayList<Integer> actual = Arraz.makeMeAnArrayListFromArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test1ArrayFromList() {
        ArrayList<Integer> input = new ArrayList<Integer>();
        input.add(3);
        input.add(4);
        input.add(9);
        input.add(2);
        input.add(1);
        int[] expected = {3, 4, 9, 2, 1};
        int[] actual = Arraz.makeMeAnArrayFromArrayList(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test2ArrayFromList() {
        ArrayList<Integer> input = new ArrayList<Integer>();
        input.add(8);
        input.add(2);
        int[] expected = {8, 2};
        int[] actual = Arraz.makeMeAnArrayFromArrayList(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test1check2ArraysEqual() {
        int[] input = {3, 4, 9, 2, 1};

        assertTrue(Arraz.check2ArraysForEqual(input, input));
    }

    @Test
    public void test2check2ArraysEqual() {
        int[] input1 = {8, 2, 3, 5, 7, 1, 9};
        int[] input2 = {3, 4, 9, 2, 1};

        assertFalse(Arraz.check2ArraysForEqual(input1, input2));
    }

    @Test
    public void test1averageWOMaxMin() {
        int[] input = {3, 4, 9, 2, 1};
        int expected = 3;
        int actual = Arraz.averageArrayWithoutMaxMin(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test2averageWOMaxMin() {
        int[] input = {8, 2, 3, 5, 7, 1, 9};
        int expected = 5;
        int actual = Arraz.averageArrayWithoutMaxMin(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test1arrayHas65and77() {
        int[] input = {3, 4, 9, 2, 1};

        assertFalse(Arraz.arrayHas65and77(input));
    }

    @Test
    public void test2arrayHas65and77() {
        int[] input = {8, 2, 3, 65, 77, 1, 9};

        assertTrue(Arraz.arrayHas65and77(input));
    }

    @Test
    public void test1tensTotal30() {
        int[] input = {3, 4, 9, 2, 10};

        assertFalse(Arraz.totalOfTensIs30(input));
    }

    @Test
    public void test2tensTotal30() {
        int[] input = {8, 10, 3, 65, 10, 1, 10};

        assertTrue(Arraz.totalOfTensIs30(input));
    }

    @Test
    public void test1find2ndSmallest() {
        int[] input = {3, 4, 9, 2, 1};
        int expected = 2;
        int actual = Arraz.find2ndSmallestValueFromArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test2find2ndSmallest() {
        int[] input = {8, 2, 3, 5, 7, 1, 9};
        int expected = 2;
        int actual = Arraz.find2ndSmallestValueFromArray(input);

        assertEquals(expected, actual);
    }

    @Test
    public void test1reverseCopy() {
        int[] input = {3, 4, 9, 2, 1};
        int[] expected = {1, 2, 9, 4, 3};
        int[] actual = Arraz.reverseCopyOfArray(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test2reverseCopy() {
        int[] input = {1, 2, 8};
        int[] expected = {8, 2, 1};
        int[] actual = Arraz.reverseCopyOfArray(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test1removeLastItem() {
        int[] input = {3, 4, 9, 2, 1};
        int[] expected = {3, 4, 9, 2};
        int[] actual = Arraz.removeLastItem(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test2removeLastItem() {
        int[] input = {1, 2, 8};
        int[] expected = {1, 2};
        int[] actual = Arraz.removeLastItem(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test1removeFirstItem() {
        int[] input = {3, 4, 9, 2, 1};
        int[] expected = {4, 9, 2, 1};
        int[] actual = Arraz.removeFirstItem(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test2removeFirstItem() {
        int[] input = {1, 2, 8};
        int[] expected = {2, 8};
        int[] actual = Arraz.removeFirstItem(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test1insertAtStart() {
        int[] input = {3, 4, 9, 2, 1};
        int numb = 7;
        int[] expected = {7, 3, 4, 9, 2, 1};
        int[] actual = Arraz.insertAtStart(input, numb);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test2insertIAtStart() {
        int[] input = {8, 2};
        int numb = 7;
        int[] expected = {7, 8, 2};
        int[] actual = Arraz.insertAtStart(input, numb);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test1insertAtEnd() {
        int[] input = {3, 4, 9, 2, 1};
        int numb = 7;
        int[] expected = {3, 4, 9, 2, 1, 7};
        int[] actual = Arraz.insertAtEnd(input, numb);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test2insertIAtEnd() {
        int[] input = {8, 2};
        int numb = 7;
        int[] expected = {8, 2, 7};
        int[] actual = Arraz.insertAtEnd(input, numb);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test1sortEvenOdd() {
        int[] input = {3, 4, 9, 2, 1};
        int[] expected = {4, 2, 1, 9, 3};
        int[] actual = Arraz.sortArrayIntoEvensThenOdds(input);

        assertTrue(Arrays.equals(expected, actual));
    }

    @Test
    public void test2sortEvenOdd() {
        int[] input = {1, 3, 8, 9, 2};
        int[] expected = {8, 2, 9, 3, 1};
        int[] actual = Arraz.sortArrayIntoEvensThenOdds(input);

        assertTrue(Arrays.equals(expected, actual));
    }



}